%file for reading SMPS raw data file

%v2 takes a data file without the data in columns 
clear
fid1=fopen('somedataTSI.txt','r');

line='llllllllllllllll';
while ~strcmp(line(1:6),'Weight')
    line=fgetl(fid1);
    if strcmp(line(1:9),'DMA Inner')
        r1=str2num(line(22:27))/100; %m
    elseif strcmp(line(1:9),'DMA Outer')
        i=find(isspace(line), 1, 'last' );
        r2= str2num(line(i+1:end))/100; %m
        %r2=str2num(line(22:27));
    elseif strcmp(line(1:9),'DMA Chara')
        i=find(isspace(line), 1, 'last' );
        L= str2num(line(i+1:end))/100; %m
    elseif strcmp(line(1:10),'Detector M')    
        detector=str2num(line(16:19));
    elseif strcmp(line(1:9),'HV Polari')
        polarity=line(13:15);
    elseif strcmp(line(1:9),'Tube Leng')
        tubeDMA2CPC=str2num(line(18:end))/100; %m
    end
    
    
end
pos_begin_header=ftell(fid1); %position of cursor at the beginning of header line.
%fscanf(fid1,'%f')
header_line=fgetl(fid1);

%now go back to a position in the headler line and load the time vector
fseek(fid1,pos_begin_header+find(unicode2native(header_line)==unicode2native(')'), 1, 'last' )+2,'bof');
tvecRaw=fscanf(fid1,'%f');
fgetl(fid1);%brings us to the beginning of next line.

%From now on there are 3 lines per scan.
%The format of the first of these three lines depends on the format of the
%header_line. Before looking into the data, we need to find the length of a
%diameter vector in the header line:
character_number=find(header_line(1:200)==')', 1, 'last' );
header_line_shortened=header_line(character_number+1:end)
Ndiameters=length(sscanf(header_line_shortened,'%f'));

%The commands inside the loop reads through the three lines of a scan and
%extracts the needed data.
nScans=100;
for iScan=1:nScans
fscanf(fid1,'%u',1)
timeStampString{iScan}=fscanf(fid1,'%s',2);
parameters=fscanf(fid1,'%f');
T(iScan)=parameters(1)+273.15; %K 
lambda(iScan)=parameters(4); %m
visc(iScan)=parameters(5); %Pa*s
t_scan(iScan)=parameters(Ndiameters+6); %s
t_retrace=parameters(Ndiameters+7); %s
scan_resolution(iScan)=parameters(Ndiameters+8); % Hz
Qsh(iScan)=parameters(Ndiameters+10)/60/1000; %m^3/s
Qa(iScan)=parameters(Ndiameters+11)/60/1000; %m^3/s
V_min(iScan)=parameters(Ndiameters+13); %V
V_max(iScan)=parameters(Ndiameters+14); %V
td(iScan)=parameters(Ndiameters+18)-0.5; %s
D50(iScan)=parameters(Ndiameters+20); % nm
fgetl(fid1);%changing to the next line

string1=fscanf(fid1,'%s',3);
rawCounts(:,iScan)=fscanf(fid1,'%u');
string2=fscanf(fid1,'%s',3);
deadTimeCounts(:,iScan)=fscanf(fid1,'%u');
fgetl(fid1);
end

fclose(fid1);

if all(t_scan==t_scan(1))
    t_scan=t_scan(1);
end
%assume that V_min and V_max do not change much
%assume also voltage ramp up
V_beginscan=mean(V_min);
V_endscan=mean(V_max);

visc=mean(visc);
lambda=mean(lambda);
T=mean(T);
D50=mean(D50);

if all(Qa==Qa(1))
    Qa=Qa(1);
end
if all(Qsh==Qsh(1))
    Qsh=Qsh(1);
end
if all(td==td(1))
    td=td(1);
end
if all(scan_resolution==scan_resolution(1))
    scan_resolution=scan_resolution(1);
end



for ii=1:nScans
slashes=find(timeStampString{ii}=='/');
mm=str2num(timeStampString{ii}(1:slashes(1)-1));
dd=str2num(timeStampString{ii}(slashes(1)+1:slashes(2)-1));
year=str2num(timeStampString{ii}(slashes(2)+(1:4)));
hh=str2num(timeStampString{ii}(slashes(2)+(5:6)));
minute=str2num(timeStampString{ii}(slashes(2)+(8:9)));
ss=str2num(timeStampString{ii}(slashes(2)+(11:12)));
timeStampDOY(ii)=datenum(0,mm,dd,hh,minute,ss);
end


save scan_parameters.mat L r1 r2 V_beginscan V_endscan Qsh Qa t_scan t_retrace td detector lambda visc scan_resolution tvecRaw polarity T D50 tubeDMA2CPC
save counts.mat rawCounts timeStampDOY year Qa 

