function coeff=varaus(dp,p,temp)

%Charging efficiecy function
% Wiedensohler is used for charges (-1,-2,1 and 2) upto 1um
% All others Gunn theory
boltz=1.381e-23; %boltzmann constant, J/K
epsilon0=8.854e-12; %permitivity of free space, C^2/(N m^2)
e=1.602e-19; %C, elementary charge

alfa=zeros(2,6);

if p(1) > 0  
alfa(1,1)=-2.3484;
alfa(1,2)=0.6044;
alfa(1,3)=0.4800;
alfa(1,4)=0.0013;
alfa(1,5)=-0.1553;
alfa(1,6)=0.0320;
alfa(2,1)=-44.4756;
alfa(2,2)=79.3772;
alfa(2,3)=-62.89;
alfa(2,4)=26.4492;
alfa(2,5)=-5.748;
alfa(2,6)=0.5049;
else
alfa(1,1)=-2.3197;
alfa(1,2)=0.6175;
alfa(1,3)=0.6201;
alfa(1,4)=-0.1105;
alfa(1,5)=-0.1260;
alfa(1,6)=0.0297;
alfa(2,1)=-26.3328;
alfa(2,2)=35.9044;
alfa(2,3)=-21.4608;
alfa(2,4)=7.0867;
alfa(2,5)=-1.3088;
alfa(2,6)=0.1051;
end

coeff=zeros(length(dp),length(p));
coefft=zeros(length(dp),length(p));

 
% Widensohler charging  
for i=1:6
coefft(:,1:min(2,length(p)))= ...
coefft(:,1:min(2,length(p)))+ ... 
(alfa(1:min(2,length(p)),i)*(log10(dp ./1e-9) .^(i-1))')';
end

coeff(:,1:min(2,length(p)))= ...
10 .^coefft(:,1:min(2,length(p)));

% Large particles Gunn
iil=find(dp>1.e-6);

for i=1:2
coe=(2.0*pi*epsilon0*dp(iil)*boltz*temp)/e^2;


coeff(iil,i)=((1.0 ./sqrt(coe*2.0*pi)) .* ...
exp(-(-sign(p(1))*i-coe*0.1335) .^2 ./(2.0*coe)));


end

% More than two charges Gunn
for i=3:length(p)
coe=(2.0*pi*epsilon0*dp*boltz*temp)/e^2;


coeff(:,i)=((1.0 ./sqrt(coe*2.0*pi)) .* ...
exp(-(-sign(p(1))*i-coe*0.1335) .^2 ./(2.0*coe)));

end

clear p
clear coe
